/*
 * The "Memulator" timing-accurate storage emulation environment
 * Authors: John Linwood Griffin, John Bucy, Greg Ganger
 *
 * Copyright (c) of Carnegie Mellon University, 2001-2004.
 *
 * This software is being provided by the copyright holders under the
 * following license. By obtaining, using and/or copying this software,
 * you agree that you have read, understood, and will comply with the
 * following terms and conditions:
 *
 * Permission to reproduce, use, and prepare derivative works of this
 * software is granted provided the copyright and "No Warranty" statements
 * are included with all reproductions and derivative works and associated
 * documentation. This software may also be redistributed without charge
 * provided that the copyright and "No Warranty" statements are included
 * in all redistributions.
 *
 * NO WARRANTY. THIS SOFTWARE IS FURNISHED ON AN "AS IS" BASIS.
 * CARNEGIE MELLON UNIVERSITY MAKES NO WARRANTIES OF ANY KIND, EITHER
 * EXPRESSED OR IMPLIED AS TO THE MATTER INCLUDING, BUT NOT LIMITED
 * TO: WARRANTY OF FITNESS FOR PURPOSE OR MERCHANTABILITY, EXCLUSIVITY
 * OF RESULTS OR RESULTS OBTAINED FROM USE OF THIS SOFTWARE. CARNEGIE
 * MELLON UNIVERSITY DOES NOT MAKE ANY WARRANTY OF ANY KIND WITH RESPECT
 * TO FREEDOM FROM PATENT, TRADEMARK, OR COPYRIGHT INFRINGEMENT.
 * COPYRIGHT HOLDERS WILL BEAR NO LIABILITY FOR ANY USE OF THIS SOFTWARE
 * OR DOCUMENTATION.
 *
 */

#ifndef MEMULATOR_H
#define MEMULATOR_H

#define MEMULATOR_SOCKET_FILENAME	"/tmp/memulator_socket"


typedef struct ipc_message {
#define IPC_MAGIC	(0x16abc047)
  int magic;

#define IPC_SOURCE_MEMULATOR	(1)
#define IPC_SOURCE_STORE	(2)
#define IPC_SOURCE_LOGIC	(3)
#define IPC_SOURCE_CLOCK	(4)
  u_int16_t source;

#define IPC_TYPE_CONNECT	(1)
#define IPC_TYPE_DISCONNECT	(2)
#define IPC_TYPE_PARAMETERS	(3)
#define IPC_TYPE_READ		(4)
#define IPC_TYPE_WRITE		(5)
#define IPC_TYPE_REQUEST_OK	(6)
#define IPC_TYPE_ADMIN_READ	(7)
#define IPC_TYPE_ADMIN_WRITE	(8)
#define IPC_TYPE_ADMIN_OK	(9)
#define IPC_TYPE_INTERPOSE_READ	(10)
#define IPC_TYPE_INTERPOSE_OK	(11)
  u_int16_t type;

  int64_t request_offset_blocks;
  int request_length_blocks;
  int serial;
  u_int64_t ts_begin;
  u_int64_t ts_end;
} ipc_message_t;


#endif /* !defined MEMULATOR_H */
