#!/usr/bin/perl

use English;
use FileHandle;
require "subroutines.pm";

$script_dir = "experiments-final";


#$run_postmark = 10;
$run_postmark_localdisk = 1;
$run_postmark_cheetah_adaptec = 1;
$run_postmark_fiftyKrpm_adaptec = 1;
$run_postmark_mems_adaptec      = 1;
$run_postmark_immediate_adaptec = 1;
#$run_postmark_cheetah_qlogic  = 1;
#$run_postmark_fiftyKrpm_qlogic  = 1;
#$run_postmark_mems_qlogic       = 1;
#$run_postmark_immediate_qlogic  = 1;

#$run_sshbuild = 10;
$run_sshbuild_localdisk = 1;
$run_sshbuild_cheetah_adaptec = 1;
$run_sshbuild_fiftyKrpm_adaptec = 1;
$run_sshbuild_mems_adaptec      = 1;
$run_sshbuild_immediate_adaptec = 1;

#$run_linuxbuild = 10;
$run_linuxbuild_localdisk = 1;
$run_linuxbuild_cheetah_adaptec = 1;
$run_linuxbuild_fiftyKrpm_adaptec = 1;
$run_linuxbuild_mems_adaptec      = 1;
$run_linuxbuild_immediate_adaptec = 1;

$run_trace = 2;
#$run_trace_postmark_immediate_adaptec = 1;
#$run_trace_sshbuild_immediate_adaptec = 1;
$run_trace_linuxbuild_immediate_adaptec = 1;



sub prepare {
    $runid = `date +%s`; chomp ($runid);
    $rundir = "/home/griffin2/workbench/$script_dir/runs/$runstr/$runid";
    print "rundir: $rundir\n";
    system "mkdir -p $rundir";
    system "chmod 777 $rundir";

    @stamps = ();
    $stampsfile = "$rundir/stamps";
    $sourcefile = "$rundir/source";

    open (STAMPS, ">$stampsfile") || die "$stampsfile";
    open (SOURCE, ">$sourcefile") || die "$sourcefile";

    autoflush STAMPS 1;
    autoflush SOURCE 1;

    open_log($rundir);

    print SOURCE "% $runstr\n";
    print SOURCE "% Begin: " . `date`;
}


sub adaptec_connect {
    ## connect emulator
    targ_start_memulator_notimes();
    targ_verify_memulator();
    host_add_single_device();
    targ_stop_memulator();
}


sub qlogic_connect {
    ## connect emulator
    host_rmmod_qla2200();
    targ_start_memulator_notimes();
    targ_verify_memulator();
    host_insmod_qla2200();
    targ_stop_memulator();
}


sub config_cheetah {
    $command = "ln -sf cheetah.parv /home/griffin2/proj/memulator/src/memulator/parfile";
    print "$command\n";
    system $command;
}


sub config_fiftyKrpm {
    $command = "ln -sf fiftyKrpm.parv /home/griffin2/proj/memulator/src/memulator/parfile";
    print "$command\n";
    system $command;
}


sub config_mems {
    $command = "ln -sf mems.g2.parv /home/griffin2/proj/memulator/src/memulator/parfile";
    print "$command\n";
    system $command;
}


sub mount_and_do_postmark {
    ## run postmark
    host_mount();
    ssh_cmd("root\@$host_name", "cp /home/griffin2/workbench/$script_dir/bin/postmark* /mnt/memulator", 0);
    ssh_cmd("root\@$host_name", "(cd /mnt/memulator ; /usr/bin/time -p -o $rundir/postmark.times ./postmark postmark-small.config)", 0);
    host_umount();
}


sub execute_postmark {
    $timestamp = `date +%s`; chomp($timestamp);
    mkdir "$results_dir/$timestamp", 0777 
	or die "Cannot mkdir $results_dir/$timestamp\n";
    chmod 0777, "$results_dir/$timestamp";

    print STAMPS "$timestamp\n";
    print SOURCE "\\newcommand{$latexcmd}{$timestamp} % $trace $runstr $extraflags\n";

    if ($is_remote == 0) {
	disable_localdisk_caching();
	blank_localdisk();
    } else {
	targ_start_memulator_times($timestamp);
	targ_verify_memulator();
    }
    ## start timepoint collection
    host_insmod_hosttimes($timestamp);

    mount_and_do_postmark();

    ## stop timepoint collection
    host_rmmod_hosttimes();
    if ($is_remote == 0) {
	## do nothing
    } else {
	targ_stop_memulator();
    }

    sleep 2;
}


sub mount_and_do_sshbuild {
    $unpack_cmd = "tar xf /home/griffin2/workbench/$script_dir/bin/ssh-1.2.27.tar > /dev/null 2>&1";
    $configure_cmd = "./configure --without-x > /dev/null 2>&1";
    $make_cmd = "make > /dev/null 2>&1";

    ## run sshbuild
    log_entry("warmup\n");
    ssh_cmd("root\@$host_name", "(rm -rf /tmp/sshbuild ; mkdir /tmp/sshbuild ; cd /tmp/sshbuild ; $unpack_cmd)", 0);
    ssh_cmd("root\@$host_name", "(cd /tmp/sshbuild/ssh-1.2.27 ; $configure_cmd)", 0);
    ssh_cmd("root\@$host_name", "(cd /tmp/sshbuild/ssh-1.2.27 ; $make_cmd)", 0);
    ssh_cmd("root\@$host_name", "(rm -rf /tmp/sshbuild)", 0);
    sleep 2;

    host_mount();
    log_entry("unpack\n");
    ssh_cmd("root\@$host_name", "(cd /mnt/memulator ; /usr/bin/time -p -o $rundir/unpack.times $unpack_cmd)", 0);
    host_umount();

    sleep 2;

    host_mount();
    log_entry("configure\n");
    ssh_cmd("root\@$host_name", "(cd /mnt/memulator/ssh-1.2.27 ; /usr/bin/time -p -o $rundir/configure.times $configure_cmd)", 0);
    host_umount();

    sleep 2;

    host_mount();
    log_entry("build\n");
    ssh_cmd("root\@$host_name", "(cd /mnt/memulator/ssh-1.2.27 ; /usr/bin/time -p -o $rundir/make.times $make_cmd)", 0);
    host_umount();

    sleep 2;
}


sub execute_sshbuild {
    $timestamp = `date +%s`; chomp($timestamp);
    mkdir "$results_dir/$timestamp", 0777 
	or die "Cannot mkdir $results_dir/$timestamp\n";
    chmod 0777, "$results_dir/$timestamp";

    print STAMPS "$timestamp\n";
    print SOURCE "\\newcommand{$latexcmd}{$timestamp} % $trace $runstr $extraflags\n";

    if ($is_remote == 0) {
	disable_localdisk_caching();
	blank_localdisk();
    } else {
	targ_start_memulator_times($timestamp);
	targ_verify_memulator();
    }
    ## start timepoint collection
    host_insmod_hosttimes($timestamp);

    mount_and_do_sshbuild();

    ## stop timepoint collection
    host_rmmod_hosttimes();
    if ($is_remote == 0) {
	## do nothing
    } else {
	targ_stop_memulator();
    }

    sleep 2;
}


sub mount_and_do_linuxbuild {
    $make_cmd = "make dep bzImage modules > /dev/null 2>&1";

#    ## run linuxbuild
#    log_entry("warmup\n");
#    ssh_cmd("root\@$host_name", "cat /home/griffin2/workbench/$script_dir/bin/linux-2.4.27-config.tar >> /dev/null");
#
#    sleep 2;
#
#    host_mount();
#    log_entry("unpack\n");
#    ssh_cmd("root\@$host_name", "(cd /mnt/memulator ; /usr/bin/time -p -o $rundir/unpack.times $unpack_cmd)", 0);
#    host_umount();
#
#    sleep 2;

    host_mount();
    log_entry("build\n");
    ssh_cmd("root\@$host_name", "(cd /mnt/memulator/linux-2.4.27 ; /usr/bin/time -p -o $rundir/make.times $make_cmd)", 0);
    host_umount();

    sleep 10;
}


sub execute_linuxbuild {
    $timestamp = `date +%s`; chomp($timestamp);
    mkdir "$results_dir/$timestamp", 0777 
	or die "Cannot mkdir $results_dir/$timestamp\n";
    chmod 0777, "$results_dir/$timestamp";

    print STAMPS "$timestamp\n";
    print SOURCE "\\newcommand{$latexcmd}{$timestamp} % $trace $runstr $extraflags\n";

    if ($is_remote == 0) {
	disable_localdisk_caching();
	blank_localdisk_linuxbuild();
    } else {
	targ_start_memulator_times($timestamp);
	targ_verify_memulator();
    }
    ## start timepoint collection
    host_insmod_hosttimes($timestamp);

    mount_and_do_linuxbuild();

    ## stop timepoint collection
    host_rmmod_hosttimes();
    if ($is_remote == 0) {
	## do nothing
    } else {
	targ_stop_memulator();
    }

    sleep 2;
}


sub adaptec_disconnect {
    ## disconnect emulator
    targ_start_memulator_quick();
    host_remove_single_device();
    targ_stop_memulator();
}


sub qlogic_disconnect {
    ## disconnect emulator
    targ_start_memulator_quick();
    host_rmmod_qla2200();
    targ_stop_memulator();
}


sub complete {
    close_log();
    close (SOURCE);
    close (STAMPS);
}


########################################################################
## postmark

for ($outerloop = $run_postmark;
     $outerloop > 0;
     $outerloop--) {

    for ($innerloop = $run_postmark_localdisk;
	 $innerloop > 0;
	 $innerloop--) {

	print `date`;
	$runstr = "postmark-l";
	$extraflags = ();

	config_localdisk();
	prepare();

	execute_postmark();

	complete();
    }

    for ($innerloop = $run_postmark_cheetah_adaptec;
	 $innerloop > 0;
	 $innerloop--) {

	print `date`;
	$runstr = "postmark-c-a";
	$extraflags = "-k 60 -l 30 -x /usr/disk-images/896mb";

	config_cheetah();
	config_adaptec();
	prepare();
	adaptec_connect();

	execute_postmark();

	complete();
	adaptec_disconnect();
    }


    for ($innerloop = $run_postmark_cheetah_qlogic;
	 $innerloop > 0;
	 $innerloop--) {

	print `date`;
	$runstr = "postmark-c-q";
	$extraflags = "-k 151 -l 30 -x /usr/disk-images/896mb";

	config_cheetah();
	config_qlogic();
	prepare();
	qlogic_connect();

	execute_postmark();

	complete();
	qlogic_disconnect();
    }


    for ($innerloop = $run_postmark_fiftyKrpm_adaptec;
	 $innerloop > 0;
	 $innerloop--) {

	print `date`;
	$runstr = "postmark-f-a";
	$extraflags = "-k 60 -l 30 -x /usr/disk-images/896mb";

	config_fiftyKrpm();
	config_adaptec();
	prepare();
	adaptec_connect();

	execute_postmark();

	complete();
	adaptec_disconnect();
    }


    for ($innerloop = $run_postmark_mems_adaptec;
	 $innerloop > 0;
	 $innerloop--) {

	print `date`;
	$runstr = "postmark-m-a";
	$extraflags = "-k 60 -l 30 -x /usr/disk-images/896mb";

	config_mems();
	config_adaptec();
	prepare();
	adaptec_connect();

	execute_postmark();

	complete();
	adaptec_disconnect();
    }


    for ($innerloop = $run_postmark_immediate_adaptec;
	 $innerloop > 0;
	 $innerloop--) {

	print `date`;
	$runstr = "postmark-i-a";
	$extraflags = "-x /usr/disk-images/896mb";

	config_adaptec();
	prepare();
	adaptec_connect();

	## inserted code from execute_postmark here

	$timestamp = `date +%s`; chomp($timestamp);
	mkdir "$results_dir/$timestamp", 0777 
	    or die "Cannot mkdir $results_dir/$timestamp\n";
	chmod 0777, "$results_dir/$timestamp";

	print STAMPS "$timestamp\n";
	print SOURCE "\\newcommand{$latexcmd}{$timestamp} % $trace $runstr $extraflags\n";

	targ_start_memulator_notimes($timestamp);
	targ_verify_memulator();

	## start timepoint collection
	host_insmod_hosttimes($timestamp);

	mount_and_do_postmark();

	## stop timepoint collection
	host_rmmod_hosttimes();

	targ_stop_memulator();

	sleep 2;

	## inserted code stops

	complete();
	adaptec_disconnect();
    }

}


########################################################################
## sshbuild

for ($outerloop = $run_sshbuild;
     $outerloop > 0;
     $outerloop--) {

    for ($innerloop = $run_sshbuild_localdisk;
	 $innerloop > 0;
	 $innerloop--) {

	print `date`;
	$runstr = "sshbuild-l";
	$extraflags = ();

	config_localdisk();
	prepare();

	execute_sshbuild();

	complete();
    }

    for ($innerloop = $run_sshbuild_cheetah_adaptec;
	 $innerloop > 0;
	 $innerloop--) {

	print `date`;
	$runstr = "sshbuild-c-a";
	$extraflags = "-k 60 -l 30 -x /usr/disk-images/896mb";

	config_cheetah();
	config_adaptec();
	prepare();
	adaptec_connect();

	execute_sshbuild();

	complete();
	adaptec_disconnect();
    }


    for ($innerloop = $run_sshbuild_cheetah_qlogic;
	 $innerloop > 0;
	 $innerloop--) {

	print `date`;
	$runstr = "sshbuild-c-q";
	$extraflags = "-k 151 -l 30 -x /usr/disk-images/896mb";

	config_cheetah();
	config_qlogic();
	prepare();
	qlogic_connect();

	execute_sshbuild();

	complete();
	qlogic_disconnect();
    }


    for ($innerloop = $run_sshbuild_fiftyKrpm_adaptec;
	 $innerloop > 0;
	 $innerloop--) {

	print `date`;
	$runstr = "sshbuild-f-a";
	$extraflags = "-k 60 -l 30 -x /usr/disk-images/896mb";

	config_fiftyKrpm();
	config_adaptec();
	prepare();
	adaptec_connect();

	execute_sshbuild();

	complete();
	adaptec_disconnect();
    }


    for ($innerloop = $run_sshbuild_mems_adaptec;
	 $innerloop > 0;
	 $innerloop--) {

	print `date`;
	$runstr = "sshbuild-m-a";
	$extraflags = "-k 60 -l 30 -x /usr/disk-images/896mb";

	config_mems();
	config_adaptec();
	prepare();
	adaptec_connect();

	execute_sshbuild();

	complete();
	adaptec_disconnect();
    }


    for ($innerloop = $run_sshbuild_immediate_adaptec;
	 $innerloop > 0;
	 $innerloop--) {

	print `date`;
	$runstr = "sshbuild-i-a";
	$extraflags = "-x /usr/disk-images/896mb";

	config_adaptec();
	prepare();
	adaptec_connect();

	## inserted code from execute_sshbuild here

	$timestamp = `date +%s`; chomp($timestamp);
	mkdir "$results_dir/$timestamp", 0777 
	    or die "Cannot mkdir $results_dir/$timestamp\n";
	chmod 0777, "$results_dir/$timestamp";

	print STAMPS "$timestamp\n";
	print SOURCE "\\newcommand{$latexcmd}{$timestamp} % $trace $runstr $extraflags\n";

	targ_start_memulator_notimes($timestamp);
	targ_verify_memulator();

	## start timepoint collection
	host_insmod_hosttimes($timestamp);

	mount_and_do_sshbuild();

	## stop timepoint collection
	host_rmmod_hosttimes();

	targ_stop_memulator();

	sleep 2;

	## inserted code stops

	complete();
	adaptec_disconnect();
    }

}


## linux build

for ($outerloop = $run_linuxbuild;
     $outerloop > 0;
     $outerloop--) {

    for ($innerloop = $run_linuxbuild_localdisk;
	 $innerloop > 0;
	 $innerloop--) {

	print `date`;
	$runstr = "linuxbuild-l";
	$extraflags = ();

	config_localdisk();
	prepare();

	execute_linuxbuild();

	complete();
    }

    for ($innerloop = $run_linuxbuild_cheetah_adaptec;
	 $innerloop > 0;
	 $innerloop--) {

	print `date`;
	$runstr = "linuxbuild-c-a";
	$extraflags = "-k 60 -l 30 -x /usr/disk-images/linux-896mb";

	config_cheetah();
	config_adaptec();
	prepare();
	adaptec_connect();

	execute_linuxbuild();

	complete();
	adaptec_disconnect();
    }

    for ($innerloop = $run_linuxbuild_fiftyKrpm_adaptec;
	 $innerloop > 0;
	 $innerloop--) {

	print `date`;
	$runstr = "linuxbuild-f-a";
	$extraflags = "-k 60 -l 30 -x /usr/disk-images/linux-896mb";

	config_fiftyKrpm();
	config_adaptec();
	prepare();
	adaptec_connect();

	execute_linuxbuild();

	complete();
	adaptec_disconnect();
    }


    for ($innerloop = $run_linuxbuild_mems_adaptec;
	 $innerloop > 0;
	 $innerloop--) {

	print `date`;
	$runstr = "linuxbuild-m-a";
	$extraflags = "-k 60 -l 30 -x /usr/disk-images/linux-896mb";

	config_mems();
	config_adaptec();
	prepare();
	adaptec_connect();

	execute_linuxbuild();

	complete();
	adaptec_disconnect();
    }


    for ($innerloop = $run_linuxbuild_immediate_adaptec;
	 $innerloop > 0;
	 $innerloop--) {

	print `date`;
	$runstr = "linuxbuild-i-a";
	$extraflags = "-x /usr/disk-images/linux-896mb";

	config_adaptec();
	prepare();
	adaptec_connect();

	## inserted code from execute_linuxbuild here

	$timestamp = `date +%s`; chomp($timestamp);
	mkdir "$results_dir/$timestamp", 0777 
	    or die "Cannot mkdir $results_dir/$timestamp\n";
	chmod 0777, "$results_dir/$timestamp";

	print STAMPS "$timestamp\n";
	print SOURCE "\\newcommand{$latexcmd}{$timestamp} % $trace $runstr $extraflags\n";

	targ_start_memulator_notimes($timestamp);
	targ_verify_memulator();

	## start timepoint collection
	host_insmod_hosttimes($timestamp);

	mount_and_do_linuxbuild();

	## stop timepoint collection
	host_rmmod_hosttimes();

	targ_stop_memulator();

	sleep 2;

	## inserted code stops

	complete();
	adaptec_disconnect();
    }
}


for ($outerloop = $run_trace;
     $outerloop > 0;
     $outerloop--) {

    for ($innerloop = $run_trace_postmark_immediate_adaptec;
	 $innerloop > 0;
	 $innerloop--) {

	print `date`;
	$runstr = "tracepostmark-i-a";
	$extraflags_orig = "-x /usr/disk-images/896mb";

	$extraflags = $extraflags_orig;

	config_adaptec();
	prepare();
	adaptec_connect();

	## inserted code from execute_postmark here

	$timestamp = `date +%s`; chomp($timestamp);
	mkdir "$results_dir/$timestamp", 0777 
	    or die "Cannot mkdir $results_dir/$timestamp\n";
	chmod 0777, "$results_dir/$timestamp";

	$extraflags = $extraflags_orig . " -r /usr/disk-images/$runstr" . "-$timestamp";

	print STAMPS "$timestamp\n";
	print SOURCE "\\newcommand{$latexcmd}{$timestamp} % $trace $runstr $extraflags\n";

	targ_start_memulator_notimes($timestamp);
	targ_verify_memulator();

	## start timepoint collection
	host_insmod_hosttimes($timestamp);

	mount_and_do_postmark();

	## stop timepoint collection
	host_rmmod_hosttimes();

	targ_stop_memulator();

	sleep 2;

	## inserted code stops

	$extraflags = $extraflags_orig;

	complete();
	adaptec_disconnect();
    }

    for ($innerloop = $run_trace_sshbuild_immediate_adaptec;
	 $innerloop > 0;
	 $innerloop--) {

	print `date`;
	$runstr = "tracesshbuild-i-a";
	$extraflags_orig = "-x /usr/disk-images/896mb";

	$extraflags = $extraflags_orig;

	config_adaptec();
	prepare();
	adaptec_connect();

	## inserted code from execute_sshbuild here

	$timestamp = `date +%s`; chomp($timestamp);
	mkdir "$results_dir/$timestamp", 0777 
	    or die "Cannot mkdir $results_dir/$timestamp\n";
	chmod 0777, "$results_dir/$timestamp";

	$extraflags = $extraflags_orig . " -r /usr/disk-images/$runstr" . "-$timestamp";

	print STAMPS "$timestamp\n";
	print SOURCE "\\newcommand{$latexcmd}{$timestamp} % $trace $runstr $extraflags\n";

	targ_start_memulator_notimes($timestamp);
	targ_verify_memulator();

	## start timepoint collection
	host_insmod_hosttimes($timestamp);

	mount_and_do_sshbuild();

	## stop timepoint collection
	host_rmmod_hosttimes();

	targ_stop_memulator();

	sleep 2;

	## inserted code stops

	$extraflags = $extraflags_orig;

	complete();
	adaptec_disconnect();
    }

    for ($innerloop = $run_trace_linuxbuild_immediate_adaptec;
	 $innerloop > 0;
	 $innerloop--) {

	print `date`;
	$runstr = "tracelinuxbuild-i-a";
	$extraflags_orig = "-x /usr/disk-images/linux-896mb";

	$extraflags = $extraflags_orig;

	config_adaptec();
	prepare();
	adaptec_connect();

	## inserted code from execute_linuxbuild here

	$timestamp = `date +%s`; chomp($timestamp);
	mkdir "$results_dir/$timestamp", 0777 
	    or die "Cannot mkdir $results_dir/$timestamp\n";
	chmod 0777, "$results_dir/$timestamp";

	$extraflags = $extraflags_orig . " -r /usr/disk-images/$runstr" . "-$timestamp";

	print STAMPS "$timestamp\n";
	print SOURCE "\\newcommand{$latexcmd}{$timestamp} % $trace $runstr $extraflags\n";

	targ_start_memulator_notimes($timestamp);
	targ_verify_memulator();

	## start timepoint collection
	host_insmod_hosttimes($timestamp);

	mount_and_do_linuxbuild();

	## stop timepoint collection
	host_rmmod_hosttimes();

	targ_stop_memulator();

	sleep 2;

	## inserted code stops

	$extraflags = $extraflags_orig;

	complete();
	adaptec_disconnect();
    }

}
