#!/usr/bin/perl

use English;
use FileHandle;
require "subroutines.pm";


$paper = "experiments";
system "mkdir -p $paper";
system "chmod 777 $paper";

$graph_postmark_adaptec = 1;
$graph_postmark_localdisk = 1;
$graph_postmark_cheetah_adaptec = 1;
$graph_postmark_fiftyKrpm_adaptec = 1;
$graph_postmark_mems_adaptec      = 1;
$graph_postmark_immediate_adaptec = 1;
$graph_postmark_comparison = 1;

$graph_sshbuild_adaptec = 1;
$graph_sshbuild_localdisk = 1;
$graph_sshbuild_cheetah_adaptec = 1;
$graph_sshbuild_fiftyKrpm_adaptec = 1;
$graph_sshbuild_mems_adaptec      = 1;
$graph_sshbuild_immediate_adaptec = 1;

$graph_linuxbuild_adaptec = 1;
$graph_linuxbuild_localdisk = 1;
$graph_linuxbuild_cheetah_adaptec = 1;
$graph_linuxbuild_fiftyKrpm_adaptec = 1;
$graph_linuxbuild_mems_adaptec      = 1;
$graph_linuxbuild_immediate_adaptec = 1;

$make_summary_table = 1;
%summary = {};


# postmark adaptec

if ($graph_postmark_adaptec > 0) {

    %allstamps = ();
    %allresults = ();
    %beststamps = ();
    %finaldata = ();

    if ($graph_postmark_localdisk > 0) {
	$runstr = "postmark-l";
	calculate_postmark_summary_hosonly();
    }

    if ($graph_postmark_cheetah_adaptec > 0) {
	$runstr = "postmark-c-a";
	calculate_postmark_summary();

	my $basestr = "postmarkXcheetahXadaptec";
	my $timestamp = $beststamps{$runstr}{stamp};
	make_graphs_fixed($basestr, $timestamp);
    }

    if ($graph_postmark_fiftyKrpm_adaptec > 0) {
	$runstr = "postmark-f-a";
	calculate_postmark_summary();

	my $basestr = "postmarkXfiftyKrpmXadaptec";
	my $timestamp = $beststamps{$runstr}{stamp};
	make_graphs_fixed($basestr, $timestamp);
    }

    if ($graph_postmark_mems_adaptec > 0) {
	$runstr = "postmark-m-a";
	calculate_postmark_summary();

	my $basestr = "postmarkXmemsXadaptec";
	my $timestamp = $beststamps{$runstr}{stamp};
	make_graphs_fixed($basestr, $timestamp);
    }

    if ($graph_postmark_immediate_adaptec > 0) {
	$runstr = "postmark-i-a";
	calculate_postmark_summary_hosonly();
    }

    ## make auto figure

    my $basestr = "postmark";
    make_graphs_auto($basestr, "adaptec");

    ## make table

    make_table_adaptec("postmark");

    ## comparison graph

    make_comparison_graphs("postmark", "adaptec", $allstamps{"postmark-l"}[0], $beststamps{"postmark-c-a"}{stamp});
}


## sshbuild adaptec

if ($graph_sshbuild_adaptec > 0) {

    %allstamps = ();
    %allresults = ();
    %beststamps = ();
    %finaldata = ();

    if ($graph_sshbuild_localdisk > 0) {
	$runstr = "sshbuild-l";
	calculate_sshbuild_summary_hosonly();
    }

    if ($graph_sshbuild_cheetah_adaptec > 0) {
	$runstr = "sshbuild-c-a";
	calculate_sshbuild_summary();

	my $basestr = "sshbuildXcheetahXadaptec";
	my $timestamp = $beststamps{$runstr}{stamp};
	make_graphs_fixed($basestr, $timestamp);
    }

    if ($graph_sshbuild_fiftyKrpm_adaptec > 0) {
	$runstr = "sshbuild-f-a";
	calculate_sshbuild_summary();

	my $basestr = "sshbuildXfiftyKrpmXadaptec";
	my $timestamp = $beststamps{$runstr}{stamp};
	make_graphs_fixed($basestr, $timestamp);
    }

    if ($graph_sshbuild_mems_adaptec > 0) {
	$runstr = "sshbuild-m-a";
	calculate_sshbuild_summary();

	my $basestr = "sshbuildXmemsXadaptec";
	my $timestamp = $beststamps{$runstr}{stamp};
	make_graphs_fixed($basestr, $timestamp);
    }

    if ($graph_sshbuild_immediate_adaptec > 0) {
	$runstr = "sshbuild-i-a";
	calculate_sshbuild_summary_hosonly();
    }

    ## make auto figure

    my $basestr = "sshbuild";
    make_graphs_auto($basestr, "adaptec");

    ## make table

    make_table_adaptec("sshbuild");

    ## comparison graph

    make_comparison_graphs("sshbuild", "adaptec", $allstamps{"sshbuild-l"}[0], $beststamps{"sshbuild-c-a"}{stamp});
}



## linuxbuild adaptec

if ($graph_linuxbuild_adaptec > 0) {

    %allstamps = ();
    %allresults = ();
    %beststamps = ();
    %finaldata = ();

    if ($graph_linuxbuild_localdisk > 0) {
	$runstr = "linuxbuild-l";
	calculate_linuxbuild_summary_hosonly();
    }

    if ($graph_linuxbuild_cheetah_adaptec > 0) {
	$runstr = "linuxbuild-c-a";
	calculate_linuxbuild_summary();

	my $basestr = "linuxbuildXcheetahXadaptec";
	my $timestamp = $beststamps{$runstr}{stamp};
	make_graphs_fixed($basestr, $timestamp);
    }

    if ($graph_linuxbuild_fiftyKrpm_adaptec > 0) {
	$runstr = "linuxbuild-f-a";
	calculate_linuxbuild_summary();

	my $basestr = "linuxbuildXfiftyKrpmXadaptec";
	my $timestamp = $beststamps{$runstr}{stamp};
	make_graphs_fixed($basestr, $timestamp);
    }

    if ($graph_linuxbuild_mems_adaptec > 0) {
	$runstr = "linuxbuild-m-a";
	calculate_linuxbuild_summary();

	my $basestr = "linuxbuildXmemsXadaptec";
	my $timestamp = $beststamps{$runstr}{stamp};
	make_graphs_fixed($basestr, $timestamp);
    }

    if ($graph_linuxbuild_immediate_adaptec > 0) {
	$runstr = "linuxbuild-i-a";
	calculate_linuxbuild_summary_hosonly();
    }

    ## make auto figure

    my $basestr = "linuxbuild";
    make_graphs_auto($basestr, "adaptec");

    ## make table

    make_table_adaptec("linuxbuild");

    ## comparison graph

    make_comparison_graphs("linuxbuild", "adaptec", $allstamps{"linuxbuild-l"}[0], $beststamps{"linuxbuild-c-a"}{stamp});
}


if ($make_summary_table > 0) {

    my $basestr = "tabXexperimentsXsummary";

    my $texfile = "$paper/$basestr.tex";

    open (TEXFILE, ">$texfile") || die "$texfile";

    print TEXFILE "\\begin{table}\n";
    print TEXFILE "\\centering\n";
    print TEXFILE "\\begin{tabular}{p{0.15in}cc|cc|cc|cc|cc} \\\\ \\hline\n";

    print TEXFILE 
	"~",
	"&\\multicolumn{2}{c}{Real}",
	"&\\multicolumn{2}{c}{Emulated}",
	"&\\multicolumn{2}{c}{Emulated}",
	"&\\multicolumn{2}{c}{Emulated}",
	"&\\multicolumn{2}{c}{Emulated}",
	"\\\\ \n";
    print TEXFILE 
	"&\\multicolumn{2}{c}{Cheetah}",
	"&\\multicolumn{2}{c}{Cheetah}",
	"&\\multicolumn{2}{c}{50K\\unit{RPM}}",
	"&\\multicolumn{2}{c}{MEMS}",
	"&\\multicolumn{2}{c}{Immediate}",
	"\\\\ \n";
    print TEXFILE
	"& [s] & \\multicolumn{1}{c}{[s]}",
	"& [s] & \\multicolumn{1}{c}{[s]}",
	"& [s] & \\multicolumn{1}{c}{[s]}",
	"& [s] & \\multicolumn{1}{c}{[s]}",
	"& [s] & \\multicolumn{1}{c}{[s]}",
	"\\\\ \n";

    print TEXFILE "\\hline\n";
    print_summary_line("postmark", "postmark", "PostMark");
    print TEXFILE "\\hline\n";
    print_summary_line("sshbuild", "sshbuild", "SSH-build");
    print_summary_line("sshbuild-unpack", "sshbuild", "~~~(unpack phase)");
    print_summary_line("sshbuild-configure", "sshbuild", "~~~(configure phase)");
    print_summary_line("sshbuild-make", "sshbuild", "~~~(make phase)");
    print TEXFILE "\\hline\n";
    print_summary_line("linuxbuild", "linuxbuild", "Linux-build");

    print TEXFILE "\\hline\n";
    print TEXFILE "\\end{tabular}\n";
    print TEXFILE "\\$basestr\n";
    print TEXFILE "\\label{$basestr}\n";
    print TEXFILE "\\end{table}\n";

    close (TEXFILE);
}


sub print_summary_line {
    my ($exp, $prefix, $name) = @_;

    my $l_avg    = list_avg   (@{$summary{$exp}{"$prefix-l"}});
    my $l_stddev = list_stddev(@{$summary{$exp}{"$prefix-l"}});
    my $c_avg    = list_avg   (@{$summary{$exp}{"$prefix-c-a"}});
    my $c_stddev = list_stddev(@{$summary{$exp}{"$prefix-c-a"}});
    my $f_avg    = list_avg   (@{$summary{$exp}{"$prefix-f-a"}});
    my $f_stddev = list_stddev(@{$summary{$exp}{"$prefix-f-a"}});
    my $m_avg    = list_avg   (@{$summary{$exp}{"$prefix-m-a"}});
    my $m_stddev = list_stddev(@{$summary{$exp}{"$prefix-m-a"}});
    my $i_avg    = list_avg   (@{$summary{$exp}{"$prefix-i-a"}});
    my $i_stddev = list_stddev(@{$summary{$exp}{"$prefix-i-a"}});

    ##

    printf TEXFILE "\\multicolumn{3}{l|}{\\textbf{\\emph{%s}}} &&&&&&&\\\\\n", $name;

    printf TEXFILE "& %.2f & \\emph{(%.2f)} ", $l_avg, $l_stddev;
    printf TEXFILE "& %.2f & \\emph{(%.2f)} ", $c_avg, $c_stddev;
    printf TEXFILE "& %.2f & \\emph{(%.2f)} ", $f_avg, $f_stddev;
    printf TEXFILE "& %.2f & \\emph{(%.2f)} ", $m_avg, $m_stddev;
    printf TEXFILE "& %.2f & \\emph{(%.2f)} ", $i_avg, $i_stddev;

    print TEXFILE "\\\\ \n";

    ##

    print TEXFILE "&& ";

    printf TEXFILE "&\\multicolumn{2}{c|}{%.1f\\%%}", $c_avg / $l_avg * 100.0;
    printf TEXFILE "&\\multicolumn{2}{c|}{%.1f\\%%}", $f_avg / $l_avg * 100.0;
    printf TEXFILE "&\\multicolumn{2}{c|}{%.1f\\%%}", $m_avg / $l_avg * 100.0;
    printf TEXFILE "&\\multicolumn{2}{c}{%.1f\\%%}", $i_avg / $l_avg * 100.0;

    print TEXFILE "\\\\ \n";
}


########################################################################


sub make_graphs_fixed {
    my ($basestr, $timestamp) = @_;

    ## fixed graphs

    $texfile = "$paper/$basestr" . "Xfixed.tex";

    open (TEXFILE, ">$texfile") || die "$texfile";

    print TEXFILE "\\begin{figure}\n";
    print TEXFILE "\\centering\n";
    print TEXFILE "\\experimentsEpsArrayFixed{$basestr}\n";
    print TEXFILE "\\$basestr" . "Xfixed\n";
    print TEXFILE "\\label{$basestr" . "Xfixed}\n";
    print TEXFILE "\\end{figure}\n";

    close (TEXFILE);

    ## copy fixed graph files

    system "cp -f timestamps/$timestamp/$timestamp.per.hos_sim.ind.fixed.eps $paper/" . $basestr . "XperXindXfixed.eps";

    system "cp -f timestamps/$timestamp/$timestamp.per.hos_sim.err.fixed.eps $paper/" . $basestr . "XperXerrXfixed.eps";

    system "cp -f timestamps/$timestamp/$timestamp.per.hos_sim.pct.fixed.eps $paper/" . $basestr . "XperXpctXfixed.eps";

    system "cp -f timestamps/$timestamp/$timestamp.agg.hos_sim.fixed.eps $paper/" . $basestr . "XaggXfixed.eps";

    ## copy auto graph files

    system "cp -f timestamps/$timestamp/$timestamp.per.hos_sim.ind.auto.eps $paper/" . $basestr . "XperXindXauto.eps";
}


sub make_graphs_auto {
    my ($basestr, $suffix) = @_;

    ## auto graph

    $texfile = "$paper/$basestr" . "X$suffix" . "Xauto.tex";

    open (TEXFILE, ">$texfile") || die "$texfile";

    print TEXFILE "\\begin{figure}\n";
    print TEXFILE "\\centering\n";
    print TEXFILE "\\experimentsAutoArray\n",
	"{$basestr" . "XcheetahX$suffix" . "XperXindXauto}\n",
	"{$basestr" . "XfiftyKrpmX$suffix" . "XperXindXauto}\n",
	"{$basestr" . "XmemsX$suffix" . "XperXindXauto}\n";
    print TEXFILE "\\$basestr" . "X$suffix" . "Xauto\n";
    print TEXFILE "\\label{$basestr" . "Xauto}\n";
    print TEXFILE "\\end{figure}\n";

    close (TEXFILE);
}


sub make_table_adaptec {
    my ($benchmark) = @_;

    $basestr = "$benchmark" . "Xadaptec";

    $texfile = "$paper/$basestr.tex";

    open (TEXFILE, ">$texfile") || die "$texfile";
    print TEXFILE "\\begin{sidewaystable}\n";
    print TEXFILE "\\centering\n";
    print TEXFILE "\\begin{tabular}{rccc|cc|cc|cc|cc} \\hline \n";
    print TEXFILE 
	"&&\\multicolumn{2}{c}{Real}",
	"&\\multicolumn{2}{c}{Emulated}",
	"&\\multicolumn{2}{c}{Emulated}",
	"&\\multicolumn{2}{c}{Emulated}",
	"&\\multicolumn{2}{c}{Emulated}",
	"\\\\ \n";
    print TEXFILE 
	"&&\\multicolumn{2}{c}{Cheetah}",
	"&\\multicolumn{2}{c}{Cheetah}",
	"&\\multicolumn{2}{c}{50K\\unit{RPM}}",
	"&\\multicolumn{2}{c}{MEMS}",
	"&\\multicolumn{2}{c}{Immediate}",
	"\\\\ \n";
    print TEXFILE "\\cline{3-12}\n";
    printf TEXFILE "&&\\multicolumn{10}{l}{%s} \\\\ \n", "\\textbf{\\emph{Application run times (averaged across all runs)}}";
    adaptec_doubleentry($benchmark, "Run time & s", "runtime");
    adaptec_tableentry($benchmark, "Minimum run time & s", "runtime_min");
    adaptec_tableentry($benchmark, "Maximum run time & s", "runtime_max");

    print TEXFILE "\\cline{3-12}\n";
    printf TEXFILE "&&\\multicolumn{10}{l}{%s} \\\\ \n", "\\textbf{\\emph{Request comparison metrics (averaged across all runs)}}";
    adaptec_tableentry_d($benchmark, "Total requests & \\#", "N_avg");
    adaptec_doubleentry($benchmark, "\\DeltaTCbar~(in host) & ms", "DeltaTCbar");
    adaptec_doubleentry($benchmark, "\\DeltaTRbar~(in simulator) & ms", "DeltaTRbar");
    adaptec_doubleentry($benchmark, "\\eiavg & ms",      "EIavg");
    adaptec_doubleentry($benchmark, "\\eiavgpct & \\%",   "EIavgpct");
    adaptec_doubleentry($benchmark, "\\eirms & ms",      "EIrms");
    adaptec_doubleentry($benchmark, "\\eirmspct & \\%",   "EIrmspct");
    adaptec_doubleentry($benchmark, "\\earms & ms",      "EArms");
    adaptec_doubleentry($benchmark, "\\earmspct & \\%",   "EArmspct");

    print TEXFILE "\\cline{3-12}\n";
    printf TEXFILE "&&\\multicolumn{10}{l}{%s} \\\\ \n", "\\textbf{\\emph{Request comparison metrics (for the run with the best \\eiavg)}}";
    adaptec_best_times($benchmark);
    adaptec_best_entry_d($benchmark, "Total requests & \\#", "N");
    adaptec_best_entry($benchmark, "\\DeltaTCbar~(in host) & ms", "DeltaTCbar");
    adaptec_best_entry($benchmark, "\\DeltaTRbar~(in simulator) & ms", "DeltaTRbar");
    adaptec_best_entry($benchmark, "\\eiavg & ms", "EIavg");
    adaptec_best_entry($benchmark, "\\eiavgpct & \\%", "EIavgpct");
    adaptec_best_entry($benchmark, "\\eirms & ms", "EIrms");
    adaptec_best_entry($benchmark, "\\eirmspct & \\%", "EIrmspct");
    adaptec_best_entry($benchmark, "\\earms & ms", "EArms");
    adaptec_best_entry($benchmark, "\\earmspct & \\%", "EArmspct");
    
    print TEXFILE "\\hline\n";
    print TEXFILE "\\end{tabular}\n";
    print TEXFILE "\\$basestr\n";
    print TEXFILE "\\label{$basestr}\n";
    print TEXFILE "\\end{sidewaystable}\n";
    close (TEXFILE);
}


sub adaptec_doubleentry {
    my ($exp, $name, $stat) = @_;
    printf TEXFILE "%s", $name;

    if ($name =~ /pct/) {
	$printcmd = "%.1f";
    } elsif ($name =~ /time/) {
	$printcmd = "%.2f";
    } else {
	$printcmd = "%.3f";
    }

    if ($finaldata{"$exp-l"}{$stat . "_avg"} != 0) {
	printf TEXFILE 
	    "& $printcmd",
	    $finaldata{"$exp-l"}{$stat . "_avg"};
	printf TEXFILE
	    "&\\emph{($printcmd)}", 
	    $finaldata{"$exp-l"}{$stat . "_stddev"};
    } else {
	print TEXFILE "&\\multicolumn{2}{c|}{}";
    }

    printf TEXFILE 
	"&$printcmd",
	$finaldata{"$exp-c-a"}{$stat . "_avg"};
    printf TEXFILE
	"&\\emph{($printcmd)}", 
	$finaldata{"$exp-c-a"}{$stat . "_stddev"};

    printf TEXFILE 
	"&$printcmd",
	$finaldata{"$exp-f-a"}{$stat . "_avg"};
    printf TEXFILE
	"&\\emph{($printcmd)}", 
	$finaldata{"$exp-f-a"}{$stat . "_stddev"};

    printf TEXFILE 
	"&$printcmd",
	$finaldata{"$exp-m-a"}{$stat . "_avg"};
    printf TEXFILE
	"&\\emph{($printcmd)}", 
	$finaldata{"$exp-m-a"}{$stat . "_stddev"};

    if ($finaldata{"$exp-i-a"}{$stat . "_avg"} != 0) {
	printf TEXFILE 
	    "&$printcmd",
	    $finaldata{"$exp-i-a"}{$stat . "_avg"};
	printf TEXFILE
	    "&\\emph{($printcmd)}", 
	    $finaldata{"$exp-i-a"}{$stat . "_stddev"};
    } else {
	print TEXFILE "&\\multicolumn{2}{c}{}";
    }

    print TEXFILE " \\\\\n";
}


sub adaptec_tableentry {
    my ($exp, $name, $stat) = @_;
    printf TEXFILE "%s &", $name;

    if ($name =~ /pct/) {
	$printcmd = "%.1f";
    } elsif ($name =~ /time/) {
	$printcmd = "%.2f";
    } else {
	$printcmd = "%.3f";
    }

    print TEXFILE "\\multicolumn{2}{c|}{";
    if ($finaldata{"$exp-l"}{$stat} != 0) {
	printf TEXFILE "$printcmd", $finaldata{"$exp-l"}{$stat};
    }
    print TEXFILE "}&";

    printf TEXFILE "\\multicolumn{2}{c|}{$printcmd}&", $finaldata{"$exp-c-a"}{$stat};

    printf TEXFILE "\\multicolumn{2}{c|}{$printcmd}&", $finaldata{"$exp-f-a"}{$stat};

    printf TEXFILE "\\multicolumn{2}{c|}{$printcmd}&", $finaldata{"$exp-m-a"}{$stat};

    if ($finaldata{"$exp-i-a"}{$stat} != 0) {
	printf TEXFILE "\\multicolumn{2}{c}{$printcmd}", $finaldata{"$exp-i-a"}{$stat};
    } else {
	print TEXFILE "&";
    }

    print TEXFILE " \\\\\n";
}


sub adaptec_best_times {
    my ($exp) = @_;
    my $name = "Run time & s";
    my $runstr;
    my $printcmd = "%.2f";

    printf TEXFILE "%s &", $name;

    print TEXFILE "\\multicolumn{2}{c|}{}&";

    $runstr = "$exp-c-a";
    printf TEXFILE "\\multicolumn{2}{c|}{$printcmd}&",
	$allresults{$runstr}{$beststamps{$runstr}{stamp}}{time}{real};

    $runstr = "$exp-f-a";
    printf TEXFILE "\\multicolumn{2}{c|}{$printcmd}&",
	$allresults{$runstr}{$beststamps{$runstr}{stamp}}{time}{real};

    $runstr = "$exp-m-a";
    printf TEXFILE "\\multicolumn{2}{c|}{$printcmd}&",
	$allresults{$runstr}{$beststamps{$runstr}{stamp}}{time}{real};

    print TEXFILE "\\multicolumn{2}{c}{}";

    printf TEXFILE "\\\\ \n";
}
    

sub adaptec_best_entry {
    my ($exp, $name, $stat) = @_;
    my $runstr;

    if ($name =~ /pct/) {
	$printcmd = "%.1f";
    } else {
	$printcmd = "%.3f";
    }

    printf TEXFILE "%s &", $name;

    print TEXFILE "\\multicolumn{2}{c|}{}&";

    $runstr = "$exp-c-a";
    printf TEXFILE "\\multicolumn{2}{c|}{$printcmd}&",
	$allresults{$runstr}{$beststamps{$runstr}{stamp}}{stats}{$stat};

    $runstr = "$exp-f-a";
    printf TEXFILE "\\multicolumn{2}{c|}{$printcmd}&",
	$allresults{$runstr}{$beststamps{$runstr}{stamp}}{stats}{$stat};

    $runstr = "$exp-m-a";
    printf TEXFILE "\\multicolumn{2}{c|}{$printcmd}&",
	$allresults{$runstr}{$beststamps{$runstr}{stamp}}{stats}{$stat};

    print TEXFILE "\\multicolumn{2}{c}{}";

    printf TEXFILE "\\\\ \n";
}


sub adaptec_best_entry_d {
    my ($exp, $name, $stat) = @_;
    my $runstr;

    printf TEXFILE "%s &", $name;

    print TEXFILE "\\multicolumn{2}{c|}{}&";

    $runstr = "$exp-c-a";
    printf TEXFILE "\\multicolumn{2}{c|}{%d}&",
	$allresults{$runstr}{$beststamps{$runstr}{stamp}}{stats}{$stat};

    $runstr = "$exp-f-a";
    printf TEXFILE "\\multicolumn{2}{c|}{%d}&",
	$allresults{$runstr}{$beststamps{$runstr}{stamp}}{stats}{$stat};

    $runstr = "$exp-m-a";
    printf TEXFILE "\\multicolumn{2}{c|}{%d}&",
	$allresults{$runstr}{$beststamps{$runstr}{stamp}}{stats}{$stat};

    print TEXFILE "\\multicolumn{2}{c}{}";

    printf TEXFILE "\\\\ \n";
}


sub adaptec_tableentry_d {
    my ($exp, $name, $stat) = @_;
    printf TEXFILE 
	"%s &", $name;
    printf TEXFILE 
	"\\multicolumn{2}{c|}{%d}&", $finaldata{"$exp-l"}{$stat};
    printf TEXFILE 
	"\\multicolumn{2}{c|}{%d}&", $finaldata{"$exp-c-a"}{$stat};
    printf TEXFILE 
	"\\multicolumn{2}{c|}{%d}&", $finaldata{"$exp-f-a"}{$stat};
    printf TEXFILE 
	"\\multicolumn{2}{c|}{%d}&", $finaldata{"$exp-m-a"}{$stat};
    printf TEXFILE 
	"\\multicolumn{2}{c}{%d}", $finaldata{"$exp-i-a"}{$stat};
    print TEXFILE 
	"\\\\ \n";
}


sub calculate_postmark_summary {
    # Allstamps is a hash indexed by all the lookahead values used.
    # We want to read in all the source files, and identify the minimum
    # value of EIavg calculated across all the runs.

    foreach $runid (`ls -1 runs/$runstr`) {
	chomp $runid;

	my $stampsfile = "runs/$runstr/$runid/stamps";
	open (STAMPS, "$stampsfile") or die "$stampsfile";
	my $timestamp = <STAMPS>;
	chomp $timestamp;
	push @{$allstamps{$runstr}}, $timestamp;
	close (STAMPS);

	my $times = {};
	my $timesfile = "runs/$runstr/$runid/postmark.times";
	open (TIMES, "$timesfile") or die "$timesfile";
	while (<TIMES>) {
	    die if ($name eq "Command");
	    my ($name, $value) = split;
	    $times->{$name} = $value;
	}
	close (TIMES);
	$allresults{$runstr}{$timestamp}{time} = $times;
	push @{$summary{"postmark"}{$runstr}}, $times->{real};
    }

    # Process the data in the source files, if necessary.

    if (1) {
	foreach $timestamp (@{$allstamps{$runstr}}) {
	    system "mkdir -p timestamps";
	    if (!(-e "timestamps/$timestamp")) {
		print "processing $timestamp\n";
		system "cp -fr $results_dir/$timestamp timestamps/$timestamp";

		merge_copy($timestamp);
		process_data_copy($timestamp);
	    }
	}
    }

    # Now read in the statistics for each run

    foreach $timestamp (@{$allstamps{$runstr}}) {
	foreach my $perwhich ("per.hos_sim", "agg.hos_sim") {
	    my $statsfile = "timestamps/$timestamp/$timestamp.$perwhich.stats";
	    open (STATS, "$statsfile") or die "Cannot open $statsfile\n";
	    while (<STATS>) {
		my ($variable, $equals, $value, $units) = split;
		$allresults{$runstr}{$timestamp}{stats}{$variable} = $value;
		if ($variable eq "EIavg") {
		    if (!defined($beststamps{$runstr})
			or $beststamps{$runstr}{EIavg} > $value) {
			$beststamps{$runstr}{stamp} = $timestamp;
			$beststamps{$runstr}{EIavg} = $value;
		    }
		}
	    }
	    close (STATS);
	}
    }

    # Finally, calculate all the interesting values

    ## Application run time
    @list = ();
    foreach $timestamp (@{$allstamps{$runstr}}) {
	push @list, $allresults{$runstr}{$timestamp}{time}{real};
    }
    $finaldata{$runstr}{runtime_avg}    = list_avg(@list);
    $finaldata{$runstr}{runtime_stddev} = list_stddev(@list);
    $finaldata{$runstr}{runtime_min}    = list_min(@list);
    $finaldata{$runstr}{runtime_max}    = list_max(@list);

    ## Other statistics
    foreach $stat (N,
		   DeltaTRbar,
		   DeltaTRmin,
		   DeltaTRmax,
		   DeltaTCbar,
		   DeltaTCmin,
		   DeltaTCmax,
		   EIavg,
		   EIavgpct,
		   EImin,
		   EIminpct,
		   EImax,
		   EImaxpct,
		   EIrms,
		   EIrmspct,
		   EArms,
		   EArmspct) {
	calculate_stats_across_all_runs($stat);
    }
}


sub calculate_postmark_summary_hosonly {

    # Allstamps is a hash indexed by all the lookahead values used.
    # We want to read in all the source files, and identify the minimum
    # value of EIavg calculated across all the runs.

    foreach $runid (`ls -1 runs/$runstr`) {
	chomp $runid;

	my $stampsfile = "runs/$runstr/$runid/stamps";
	open (STAMPS, "$stampsfile") or die "$stampsfile";
	my $timestamp = <STAMPS>;
	chomp $timestamp;
	push @{$allstamps{$runstr}}, $timestamp;
	close (STAMPS);

	my $times = {};
	my $timesfile = "runs/$runstr/$runid/postmark.times";
	open (TIMES, "$timesfile") or die "$timesfile";
	while (<TIMES>) {
	    die if ($name eq "Command");
	    my ($name, $value) = split;
	    $times->{$name} = $value;
	}
	close (TIMES);
	$allresults{$runstr}{$timestamp}{time} = $times;
	push @{$summary{"postmark"}{$runstr}}, $times->{real};
    }

    # Process the data in the source files, if necessary.

    if (1) {
	foreach $timestamp (@{$allstamps{$runstr}}) {
	    system "mkdir -p timestamps";
	    if (!(-e "timestamps/$timestamp")) {
		print "processing $timestamp\n";
		system "cp -fr $results_dir/$timestamp timestamps/$timestamp";

		merge_copy_hosonly($timestamp);
		process_data_copy_hosonly($timestamp);
	    }
	}
    }

    # Now read in the statistics for each run

    foreach $timestamp (@{$allstamps{$runstr}}) {
	my $statsfile = "timestamps/$timestamp/$timestamp.per.hos.stats";
	open (STATS, "$statsfile") or die "Cannot open $statsfile\n";
	while (<STATS>) {
	    my ($variable, $equals, $value, $units) = split;
	    $allresults{$runstr}{$timestamp}{stats}{$variable} = $value;
	}
	close (STATS);
    }

    # Finally, calculate all the interesting values

    ## Application run time
    @list = ();
    foreach $timestamp (@{$allstamps{$runstr}}) {
	push @list, $allresults{$runstr}{$timestamp}{time}{real};
    }
    $finaldata{$runstr}{runtime_avg}    = list_avg(@list);
    $finaldata{$runstr}{runtime_stddev} = list_stddev(@list);
    $finaldata{$runstr}{runtime_min}    = list_min(@list);
    $finaldata{$runstr}{runtime_max}    = list_max(@list);

    ## Other statistics
    foreach $stat (N,
		   DeltaTCbar,
		   DeltaTCmin,
		   DeltaTCmax) {
	calculate_stats_across_all_runs($stat);
    }
}


########################################################################

sub calculate_sshbuild_summary {
    # Allstamps is a hash indexed by all the lookahead values used.
    # We want to read in all the source files, and identify the minimum
    # value of EIavg calculated across all the runs.

    foreach $runid (`ls -1 runs/$runstr`) {
	chomp $runid;

	my $stampsfile = "runs/$runstr/$runid/stamps";
	open (STAMPS, "$stampsfile") or die "$stampsfile";
	my $timestamp = <STAMPS>;
	chomp $timestamp;
	push @{$allstamps{$runstr}}, $timestamp;
	close (STAMPS);

	my $totaltime = {};

	foreach my $phase ("unpack", "configure", "make") {
	    my $times = {};
	    my $timesfile = "runs/$runstr/$runid/$phase.times";
	    open (TIMES, "$timesfile") or die "$timesfile";
	    while (<TIMES>) {
	    die if ($name eq "Command");
		my ($name, $value) = split;
		$times->{$name} = $value;
	    }
	    close (TIMES);
	    $allresults{$runstr}{$timestamp}{$phase} = $times;
	    $totaltime->{real} += $times->{real};
	    push @{$summary{"sshbuild-$phase"}{$runstr}}, $times->{real};
	}

	$allresults{$runstr}{$timestamp}{time} = $totaltime;
	push @{$summary{"sshbuild"}{$runstr}}, $totaltime->{real};
    }

    # Process the data in the source files, if necessary.

    if (1) {
	foreach $timestamp (@{$allstamps{$runstr}}) {
	    system "mkdir -p timestamps";
	    if (!(-e "timestamps/$timestamp")) {
		print "processing $timestamp\n";
		system "cp -fr $results_dir/$timestamp timestamps/$timestamp";

		merge_copy($timestamp);
		process_data_copy($timestamp);
	    }
	}
    }

    # Now read in the statistics for each run

    foreach $timestamp (@{$allstamps{$runstr}}) {
	foreach my $perwhich ("per.hos_sim", "agg.hos_sim") {
	    my $statsfile = "timestamps/$timestamp/$timestamp.$perwhich.stats";
	    open (STATS, "$statsfile") or die "Cannot open $statsfile\n";
	    while (<STATS>) {
		my ($variable, $equals, $value, $units) = split;
		$allresults{$runstr}{$timestamp}{stats}{$variable} = $value;
		if ($variable eq "EIavg") {
		    if (!defined($beststamps{$runstr})
			or $beststamps{$runstr}{EIavg} > $value) {
			$beststamps{$runstr}{stamp} = $timestamp;
			$beststamps{$runstr}{EIavg} = $value;
		    }
		}
	    }
	    close (STATS);
	}
    }

    # Finally, calculate all the interesting values

    ## Application run time
    @list = ();
    foreach $timestamp (@{$allstamps{$runstr}}) {
	push @list, $allresults{$runstr}{$timestamp}{time}{real};
    }
    $finaldata{$runstr}{runtime_avg}    = list_avg(@list);
    $finaldata{$runstr}{runtime_stddev} = list_stddev(@list);
    $finaldata{$runstr}{runtime_min}    = list_min(@list);
    $finaldata{$runstr}{runtime_max}    = list_max(@list);

    ## Other statistics
    foreach $stat (N,
		   DeltaTRbar,
		   DeltaTRmin,
		   DeltaTRmax,
		   DeltaTCbar,
		   DeltaTCmin,
		   DeltaTCmax,
		   EIavg,
		   EIavgpct,
		   EImin,
		   EIminpct,
		   EImax,
		   EImaxpct,
		   EIrms,
		   EIrmspct,
		   EArms,
		   EArmspct) {
	calculate_stats_across_all_runs($stat);
    }
}


sub calculate_sshbuild_summary_hosonly {

    # Allstamps is a hash indexed by all the lookahead values used.
    # We want to read in all the source files, and identify the minimum
    # value of EIavg calculated across all the runs.

    foreach $runid (`ls -1 runs/$runstr`) {
	chomp $runid;

	my $stampsfile = "runs/$runstr/$runid/stamps";
	open (STAMPS, "$stampsfile") or die "$stampsfile";
	my $timestamp = <STAMPS>;
	chomp $timestamp;
	push @{$allstamps{$runstr}}, $timestamp;
	close (STAMPS);

	my $totaltime = {};

	foreach my $phase ("unpack", "configure", "make") {
	    my $times = {};
	    my $timesfile = "runs/$runstr/$runid/$phase.times";
	    open (TIMES, "$timesfile") or die "$timesfile";
	    while (<TIMES>) {
	    die if ($name eq "Command");
		my ($name, $value) = split;
		$times->{$name} = $value;
	    }
	    close (TIMES);
	    $allresults{$runstr}{$timestamp}{$phase} = $times;
	    $totaltime->{real} += $times->{real};
	    push @{$summary{"sshbuild-$phase"}{$runstr}}, $times->{real};
	}

	$allresults{$runstr}{$timestamp}{time} = $totaltime;
	push @{$summary{"sshbuild"}{$runstr}}, $totaltime->{real};
    }

    # Process the data in the source files, if necessary.

    if (1) {
	foreach $timestamp (@{$allstamps{$runstr}}) {
	    system "mkdir -p timestamps";
	    if (!(-e "timestamps/$timestamp")) {
		print "processing $timestamp\n";
		system "cp -fr $results_dir/$timestamp timestamps/$timestamp";

		merge_copy_hosonly($timestamp);
		process_data_copy_hosonly($timestamp);
	    }
	}
    }

    # Now read in the statistics for each run

    foreach $timestamp (@{$allstamps{$runstr}}) {
	my $statsfile = "timestamps/$timestamp/$timestamp.per.hos.stats";
	open (STATS, "$statsfile") or die "Cannot open $statsfile\n";
	while (<STATS>) {
	    my ($variable, $equals, $value, $units) = split;
	    $allresults{$runstr}{$timestamp}{stats}{$variable} = $value;
	}
	close (STATS);
    }

    # Finally, calculate all the interesting values

    ## Application run time
    @list = ();
    foreach $timestamp (@{$allstamps{$runstr}}) {
	push @list, $allresults{$runstr}{$timestamp}{time}{real};
    }
    $finaldata{$runstr}{runtime_avg}    = list_avg(@list);
    $finaldata{$runstr}{runtime_stddev} = list_stddev(@list);
    $finaldata{$runstr}{runtime_min}    = list_min(@list);
    $finaldata{$runstr}{runtime_max}    = list_max(@list);

    ## Other statistics
    foreach $stat (N,
		   DeltaTCbar,
		   DeltaTCmin,
		   DeltaTCmax) {
	calculate_stats_across_all_runs($stat);
    }
}


########################################################################


sub calculate_stats_across_all_runs {
    my ($stat) = @_;
    my @list = ();
    foreach my $timestamp (@{$allstamps{$runstr}}) {
	push @list, $allresults{$runstr}{$timestamp}{stats}{$stat};
    }
    $finaldata{$runstr}{$stat . "_avg"}    = list_avg(@list);
    $finaldata{$runstr}{$stat . "_stddev"} = list_stddev(@list);
    $finaldata{$runstr}{$stat . "_min"}    = list_min(@list);
    $finaldata{$runstr}{$stat . "_max"}    = list_max(@list);
}


########################################################################

sub make_comparison_graphs {
    my ($exp, $hba, $localdisk_stamp, $cheetah_stamp) = @_;

    @localdisk_requests = process_merge_file("timestamps/$localdisk_stamp/$localdisk_stamp");

    @cheetah_requests = process_merge_file("timestamps/$cheetah_stamp/$cheetah_stamp");

    @disk = ();
    @emulator = ();
    @simulator = ();

    foreach $request (@localdisk_requests) {
	push @disk, $request->{hos_ms};
    }

    foreach $request (@cheetah_requests) {
	push @emulator, $request->{hos_ms};
	push @simulator, $request->{sim_ms};
    }

    ################################################################
    ## create sorted request list

    @disk      = sort numerically @disk;
    @emulator  = sort numerically @emulator;
    @simulator = sort numerically @simulator;

    @sorted = ();

    $N = @disk;
    $N = @emulator if ($N > @emulator);

    for (my $i = 0; $i < $N; $i++) {
	my $disk_ms      = $disk[$i];
	my $emulator_ms  = $emulator[$i];
	my $simulator_ms = $simulator[$i];

	my $simulator_disk_err_ms  = $simulator_ms - $disk_ms;
	my $simulator_disk_err_pct = $simulator_disk_err_ms / $disk_ms * 100.0;

	my $emulator_disk_err_ms   = $emulator_ms - $disk_ms;
	my $emulator_disk_err_pct  = $emulator_disk_err_ms / $disk_ms * 100.0;

	push @sorted, {
	    disk_ms      => $disk_ms,
	    emulator_ms  => $emulator_ms,
	    simulator_ms => $simulator_ms,
	    simulator_disk_err_ms  => $simulator_disk_err_ms,
	    simulator_disk_err_pct => $simulator_disk_err_pct,
	    emulator_disk_err_ms   => $emulator_disk_err_ms,
	    emulator_disk_err_pct  => $emulator_disk_err_pct,
	};
    }

    ################################################################
    ## create distributions

    my $basestr = "comparisonX$exp" . "X$hba";

    process_aggregate_stats_distribution("$paper/$basestr",
					 \@sorted, "simulator", "disk");

    process_aggregate_stats_distribution("$paper/$basestr",
					 \@sorted, "emulator", "disk");

    ################################################################
    ## create figure


    $texfile = "$paper/$basestr" . "Xfixed.tex";

    open (TEXFILE, ">$texfile") || die "$texfile";

    print TEXFILE "\\begin{figure}\n";
    print TEXFILE "\\centering\n";
    print TEXFILE "\\experimentsComparisonFixed{$basestr}\n";
    print TEXFILE "\\$basestr" . "Xfixed\n";
    print TEXFILE "\\label{$basestr" . "Xfixed}\n";
    print TEXFILE "\\end{figure}\n";

    close (TEXFILE);

}


########################################################################

sub calculate_linuxbuild_summary {
    # Allstamps is a hash indexed by all the lookahead values used.
    # We want to read in all the source files, and identify the minimum
    # value of EIavg calculated across all the runs.

    foreach $runid (`ls -1 runs/$runstr`) {
	chomp $runid;

	my $stampsfile = "runs/$runstr/$runid/stamps";
	open (STAMPS, "$stampsfile") or die "$stampsfile";
	my $timestamp = <STAMPS>;
	chomp $timestamp;
	push @{$allstamps{$runstr}}, $timestamp;
	close (STAMPS);

	my $totaltime = {};

	foreach my $phase ("make") {
	    my $times = {};
	    my $timesfile = "runs/$runstr/$runid/$phase.times";
	    open (TIMES, "$timesfile") or die "$timesfile";
	    while (<TIMES>) {
	    die if ($name eq "Command");
		my ($name, $value) = split;
		$times->{$name} = $value;
	    }
	    close (TIMES);
	    $allresults{$runstr}{$timestamp}{$phase} = $times;
	    $totaltime->{real} += $times->{real};
	    push @{$summary{"linuxbuild-$phase"}{$runstr}}, $times->{real};
	}

	$allresults{$runstr}{$timestamp}{time} = $totaltime;
	push @{$summary{"linuxbuild"}{$runstr}}, $totaltime->{real};
    }

    # Process the data in the source files, if necessary.

    if (1) {
	foreach $timestamp (@{$allstamps{$runstr}}) {
	    system "mkdir -p timestamps";
	    if (!(-e "timestamps/$timestamp")) {
		print "processing $timestamp\n";
		system "cp -fr $results_dir/$timestamp timestamps/$timestamp";

		merge_copy($timestamp);
		process_data_copy($timestamp);
	    }
	}
    }

    # Now read in the statistics for each run

    foreach $timestamp (@{$allstamps{$runstr}}) {
	foreach my $perwhich ("per.hos_sim", "agg.hos_sim") {
	    my $statsfile = "timestamps/$timestamp/$timestamp.$perwhich.stats";
	    open (STATS, "$statsfile") or die "Cannot open $statsfile\n";
	    while (<STATS>) {
		my ($variable, $equals, $value, $units) = split;
		$allresults{$runstr}{$timestamp}{stats}{$variable} = $value;
		if ($variable eq "EIavg") {
		    if (!defined($beststamps{$runstr})
			or $beststamps{$runstr}{EIavg} > $value) {
			$beststamps{$runstr}{stamp} = $timestamp;
			$beststamps{$runstr}{EIavg} = $value;
		    }
		}
	    }
	    close (STATS);
	}
    }

    # Finally, calculate all the interesting values

    ## Application run time
    @list = ();
    foreach $timestamp (@{$allstamps{$runstr}}) {
	push @list, $allresults{$runstr}{$timestamp}{time}{real};
    }
    $finaldata{$runstr}{runtime_avg}    = list_avg(@list);
    $finaldata{$runstr}{runtime_stddev} = list_stddev(@list);
    $finaldata{$runstr}{runtime_min}    = list_min(@list);
    $finaldata{$runstr}{runtime_max}    = list_max(@list);

    ## Other statistics
    foreach $stat (N,
		   DeltaTRbar,
		   DeltaTRmin,
		   DeltaTRmax,
		   DeltaTCbar,
		   DeltaTCmin,
		   DeltaTCmax,
		   EIavg,
		   EIavgpct,
		   EImin,
		   EIminpct,
		   EImax,
		   EImaxpct,
		   EIrms,
		   EIrmspct,
		   EArms,
		   EArmspct) {
	calculate_stats_across_all_runs($stat);
    }
}


sub calculate_linuxbuild_summary_hosonly {

    # Allstamps is a hash indexed by all the lookahead values used.
    # We want to read in all the source files, and identify the minimum
    # value of EIavg calculated across all the runs.

    foreach $runid (`ls -1 runs/$runstr`) {
	chomp $runid;

	my $stampsfile = "runs/$runstr/$runid/stamps";
	open (STAMPS, "$stampsfile") or die "$stampsfile";
	my $timestamp = <STAMPS>;
	chomp $timestamp;
	push @{$allstamps{$runstr}}, $timestamp;
	close (STAMPS);

	my $totaltime = {};

	foreach my $phase ("make") {
	    my $times = {};
	    my $timesfile = "runs/$runstr/$runid/$phase.times";
	    open (TIMES, "$timesfile") or die "$timesfile";
	    while (<TIMES>) {
	    die if ($name eq "Command");
		my ($name, $value) = split;
		$times->{$name} = $value;
	    }
	    close (TIMES);
	    $allresults{$runstr}{$timestamp}{$phase} = $times;
	    $totaltime->{real} += $times->{real};
	    push @{$summary{"linuxbuild-$phase"}{$runstr}}, $times->{real};
	}

	$allresults{$runstr}{$timestamp}{time} = $totaltime;
	push @{$summary{"linuxbuild"}{$runstr}}, $totaltime->{real};
    }

    # Process the data in the source files, if necessary.

    if (1) {
	foreach $timestamp (@{$allstamps{$runstr}}) {
	    system "mkdir -p timestamps";
	    if (!(-e "timestamps/$timestamp")) {
		print "processing $timestamp\n";
		system "cp -fr $results_dir/$timestamp timestamps/$timestamp";

		merge_copy_hosonly($timestamp);
		process_data_copy_hosonly($timestamp);
	    }
	}
    }

    # Now read in the statistics for each run

    foreach $timestamp (@{$allstamps{$runstr}}) {
	my $statsfile = "timestamps/$timestamp/$timestamp.per.hos.stats";
	open (STATS, "$statsfile") or die "Cannot open $statsfile\n";
	while (<STATS>) {
	    my ($variable, $equals, $value, $units) = split;
	    $allresults{$runstr}{$timestamp}{stats}{$variable} = $value;
	}
	close (STATS);
    }

    # Finally, calculate all the interesting values

    ## Application run time
    @list = ();
    foreach $timestamp (@{$allstamps{$runstr}}) {
	push @list, $allresults{$runstr}{$timestamp}{time}{real};
    }
    $finaldata{$runstr}{runtime_avg}    = list_avg(@list);
    $finaldata{$runstr}{runtime_stddev} = list_stddev(@list);
    $finaldata{$runstr}{runtime_min}    = list_min(@list);
    $finaldata{$runstr}{runtime_max}    = list_max(@list);

    ## Other statistics
    foreach $stat (N,
		   DeltaTCbar,
		   DeltaTCmin,
		   DeltaTCmax) {
	calculate_stats_across_all_runs($stat);
    }
}

