#!/usr/bin/perl

# make_trace ("t-2-r", 5000, 50, 2, 2)
# "t-2-r": t (trace) - 2 (length in blocks) - [r/w]
# 10000: number of requests for the trace
# 50: interarrival time between requests (in msec)
# 2: legth in blocks
# 2: read (3 = write)

my $num = 10000;
my $interarrival = 25;

make_trace ("t-2-r", $num, $interarrival, 2, 3);
make_trace ("t-2-w", $num, $interarrival, 2, 2);

make_trace ("t-8-r", $num, $interarrival, 8, 3);
make_trace ("t-8-w", $num, $interarrival, 8, 2);

make_trace ("t-64-r", $num, $interarrival, 64, 3);
make_trace ("t-64-w", $num, $interarrival, 64, 2);

make_trace ("t-128-r", $num, $interarrival, 128, 3);
make_trace ("t-128-w", $num, $interarrival, 128, 2);


sub make_trace {
    my ($outfile, $num_reqs, $time_inc, $length, $flags) = @_;

    my $time = 0.0;

    open (OUT, ">$outfile.synthtrace") || die "$outfile.synthtrace";

    while ($num_reqs > 0) {
	printf OUT "%f\t0\t0\t%d\t%d\n", $time, $length, $flags;
	$time += $time_inc;
	$num_reqs--;
    }

    close (OUT);
}
