#!/usr/bin/perl

use English;
use FileHandle;
require "subroutines.pm";

my $localdisk_ts = 1092156373;
#my $cheetah_ts   = 1092156698;
#my $cheetah_ts   = 1092186058;
#my $cheetah_ts   = 1092253401;
## my $cheetah_ts   = 1092254007;
# my $cheetah_ts   = 1092255179;
my $cheetah_ts = 1092276087;

my $localdisk_prefix = "$results_dir/$localdisk_ts/$localdisk_ts";
my $cheetah_prefix   = "$results_dir/$cheetah_ts/$cheetah_ts";

my @localdisk_hos = merge_load_hos($localdisk_prefix);
my @cheetah_hos   = merge_load_hos($cheetah_prefix);
my @cheetah_sim   = merge_load_sim($cheetah_prefix);

my @localdisk_times_ms = ();
my @cheetah_times_ms = ();
my @cheetah_sim_ms = ();

foreach $loc_elem (@localdisk_hos) {
    my $loc_ms = ($loc_elem->{completion} - $loc_elem->{arrival}) / $host_cycles * 1000.0;
    push @localdisk_times_ms, $loc_ms;
}

foreach $che_elem (@cheetah_hos) {
    my $che_ms = ($che_elem->{completion} - $che_elem->{arrival}) / $host_cycles * 1000.0;
    push @cheetah_times_ms, $che_ms;
}

foreach $sim_elem (@cheetah_sim) {
    push @cheetah_sim_ms, $sim_elem->{time};
}

@localdisk_times_ms = sort numerically @localdisk_times_ms;
@cheetah_times_ms = sort numerically @cheetah_times_ms;
@cheetah_sim_ms = sort numerically @cheetah_sim_ms;

my @sorted_times = ();

for (my $i = 0; $i < $#localdisk_times_ms; $i++) {
    push @sorted_times, {
	localdisk_ms => $localdisk_times_ms[$i], 
	cheetah_ms   => $cheetah_times_ms[$i],
	sim_ms       => $cheetah_sim_ms[$i],
	cheetah_localdisk_err_ms   => $localdisk_times_ms[$i] - $cheetah_times_ms[$i],
	sim_localdisk_err_ms => $localdisk_times_ms[$i] - $cheetah_sim_ms[$i],
    };
}

process_aggregate_stats_distribution("test/newtest", \@sorted_times, "sim", "localdisk");

process_aggregate_stats_distribution("test/test", \@sorted_times, "cheetah", "localdisk");



#my $localdisk_avg = process_avg(\@sorted_times, "localdisk_ms");
#my $cheetah_avg   = process_avg(\@sorted_times, "cheetah_ms");

#print "avgs: $localdisk_avg, $cheetah_avg\n";
